#include "Text.h"

/*********************************************
	Constructores
 *********************************************/
Text::Text() 
{
}

Text::Text(ifstream & infile) 
{ 
  infile >> sub_type;
  infile >> color;
  infile >> depth;
  infile >> pen_style;
  infile >> font;
  infile >> font_size;
  infile >> angle;
  infile >> font_flags;
  infile >> height;
  infile >> length;
  infile >> x;
  infile >> y;
  stringText = readText(infile);

}

/*********************************************
	Operaciones
 *********************************************/


string Text::readText(ifstream &infile) 
{
  string c;
  string h;

  infile >> c;
  while(c.substr(c.length()-1,1) != "1"){
    infile >> h;  
    c = c + " " + h;
  }

  return c;
}


//--------------------------------------------

void Text::write(void) 
{ 
  cout << object_code << ' ';  
  cout << sub_type <<' '<< color << ' '
       << depth  <<' ' << pen_style <<' ' << font << ' '
       << font_size <<' ' << angle << ' '
       << font_flags << ' ' << height <<' '
       << length <<' ' << x << ' ' << y << ' ';
  cout << stringText << '\n';
}

//--------------------------------------------

void Text::mag(int xc, int yc, double f)
{
  font_size=int(font_size*f);
  height = int(height*f);
  length = int(length*f);
  x = xc + int((x-xc)*f);
  y = yc + int((y-yc)*f);
}

//-----------------------------------------------------

void Text::trans(int xc, int yc)
{ 
  x+=xc;
  y+=xc;
}

//-----------------------------------------------------

void Text::rot(int xc, int yc, char Sentido)
{
	int A,B;					//parametros auxiliares para la rotacin
	if(Sentido == 'F'){
		A = -1;
		B =  1; 
	}
	if(Sentido == 'C'){
	    A= 1;
		B= -1;
	}

	S_swap(x,y);				// Cambiando valores de x por y
	x = xc - A*(yc - x);
	y = yc - B*(xc - y);
	angle=angle + A*(PI/2);

}


